Loading...
Searching...
No Matches
dolfin::PETScLUSolver Class Reference

`#include <PETScLUSolver.h>`

Inheritance diagram for dolfin::PETScLUSolver:
[legend]
Collaboration diagram for dolfin::PETScLUSolver:
[legend]

## Public Member Functions

| PETScLUSolver (MPI_Comm comm, std::string method="default")
| Constructor.
| PETScLUSolver (std::string method="default")
| Constructor.
| PETScLUSolver (MPI_Comm comm, std::shared_ptr< const PETScMatrix > A, std::string method="default")
| Constructor.
| PETScLUSolver (std::shared_ptr< const PETScMatrix > A, std::string method="default")
| Constructor.
| ~PETScLUSolver ()
| Destructor.
void | set_operator (std::shared_ptr< const GenericLinearOperator > A)
| Set operator (matrix).
void | set_operator (const PETScMatrix &A)
| Set operator (matrix).
std::size_t | solve (GenericVector &x, const GenericVector &b)
| Solve linear system Ax = b.
std::size_t | solve (GenericVector &x, const GenericVector &b, bool transpose)
| Solve linear system Ax = b (A^t x = b if transpose is true).
std::size_t | solve (const GenericLinearOperator &A, GenericVector &x, const GenericVector &b)
| Solve linear system Ax = b.
std::size_t | solve (const PETScMatrix &A, PETScVector &x, const PETScVector &b)
| Solve linear system Ax = b.
void | set_options_prefix (std::string options_prefix)
std::string | get_options_prefix () const
void | set_from_options () const
| Set options from the PETSc options database.
MPI_Comm | mpi_comm () const
| Returns the MPI communicator.
std::string | str (bool verbose) const
| Return informal string representation (pretty-print).
KSP | ksp () const
| Return PETSc KSP pointer.
std::string | parameter_type () const
| Return parameter type: "krylov_solver" or "lu_solver".
Public Member Functions inherited from dolfin::GenericLinearSolver
virtual void | set_operators (std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P)
| Set operator (matrix) and preconditioner matrix.
virtual void | update_parameters (const Parameters &parameters)
| Update solver parameters (useful for LinearSolver wrapper).
Public Member Functions inherited from dolfin::Variable
| Variable ()
| Create unnamed variable.
| Variable (const std::string name, const std::string label)
| Create variable with given name and label.
| Variable (const Variable &variable)
| Copy constructor.
virtual | ~Variable ()
| Destructor.
const Variable & | operator= (const Variable &variable)
| Assignment operator.
void | rename (const std::string name, const std::string label)
| Rename variable.
std::string | name () const
| Return name.
std::string | label () const
| Return label (description).
std::size_t | id () const

## Static Public Member Functions

static std::map< std::string, std::string > | methods ()
| Return a list of available solver methods.
static Parameters | default_parameters ()
| Default parameter values.

## Friends

class | PETScSNESSolver
class | PETScTAOSolver

## Additional Inherited Members

Public Attributes inherited from dolfin::Variable
Parameters | parameters
| Parameters.
Static Protected Member Functions inherited from dolfin::GenericLinearSolver
static const GenericMatrix & | require_matrix (const GenericLinearOperator &A)
static std::shared_ptr< const GenericMatrix > | require_matrix (std::shared_ptr< const GenericLinearOperator > A)

## Detailed Description

This class implements the direct solution (LU factorization) for linear systems of the form Ax = b. It is a wrapper for the LU solver of PETSc.

## Member Function Documentation

## get_options_prefix()

std::string PETScLUSolver::get_options_prefix | ( |  | ) | const

Returns the prefix used by PETSc when searching the options database

## parameter_type()

std::string dolfin::PETScLUSolver::parameter_type | ( |  | ) | const

inline virtual

Return parameter type: "krylov_solver" or "lu_solver".

Reimplemented from dolfin::GenericLinearSolver.

## set_operator()

void PETScLUSolver::set_operator | ( | std::shared_ptr< const GenericLinearOperator > | A | ) |

virtual

Set operator (matrix).

Implements dolfin::GenericLinearSolver.

## set_options_prefix()

void PETScLUSolver::set_options_prefix | ( | std::string | options_prefix | ) |

Sets the prefix used by PETSc when searching the options database

## solve() [1/2]

std::size_t PETScLUSolver::solve | ( | const GenericLinearOperator & | A,
|  | GenericVector & | x,
|  | const GenericVector & | b )

virtual

Solve linear system Ax = b.

Reimplemented from dolfin::GenericLinearSolver.

## solve() [2/2]

std::size_t PETScLUSolver::solve | ( | GenericVector & | x,
|  | const GenericVector & | b )

virtual

Solve linear system Ax = b.

Implements dolfin::GenericLinearSolver.

## str()

std::string PETScLUSolver::str | ( | bool | verbose | ) | const

virtual

Return informal string representation (pretty-print).

Reimplemented from dolfin::Variable.

The documentation for this class was generated from the following files:

- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/la/PETScLUSolver.h
- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/la/PETScLUSolver.cpp